/*
 * Copyright © 2012-2015, Intel Corporation. All rights reserved.
 * Please see the included README.md file for license terms and conditions.
 */


/*jslint browser:true, devel:true, white:true, vars:true */
/*global $:false, intel:false, app:false, dev:false */
/*global myEventHandler:false, cordova:false, device:false */



window.app = window.app || {} ;         // there should only be one of these...



// Set to "true" if you want the console.log messages to appear.

app.LOG = app.LOG || false ;

app.consoleLog = function() {           // only emits console.log messages if app.LOG != false
    if( app.LOG ) {
        var args = Array.prototype.slice.call(arguments, 0) ;
        console.log.apply(console, args) ;
    }
} ;



// App init point (runs on custom app.Ready event from init-dev.js).
// Runs after underlying device native code and webview/browser is ready.
// Where you should "kick off" your application by initializing app events, etc.

// NOTE: Customize this function to initialize your application, as needed.

app.initEvents = function() {
    "use strict" ;
    var fName = "app.initEvents():" ;
    app.consoleLog(fName, "entry") ;

    // NOTE: initialize your third-party libraries and event handlers

    // initThirdPartyLibraryNumberOne() ;
    // initThirdPartyLibraryNumberTwo() ;
    // initThirdPartyLibraryNumberEtc() ;

    // NOTE: initialize your application code

    // initMyAppCodeNumberOne() ;
    // initMyAppCodeNumberTwo() ;
    // initMyAppCodeNumberEtc() ;

    // NOTE: initialize your app event handlers, see app.js for a simple event handler example

    // TODO: configure following to work with both touch and click events (mouse + touch)
    // see http://msopentech.com/blog/2013/09/16/add-pinch-pointer-events-apache-cordova-phonegap-app/

    var el, evt ;

    if( navigator.msPointerEnabled || !('ontouchend' in window))    // if on Win 8 machine or no touch
        evt = "click" ;                                             // let touch become a click event
    else                                                            // else, assume touch events available
        evt = "touchend" ;                                          // not optimum, but works

    // NOTE: ...you can put other miscellaneous init stuff in this function...
    // NOTE: ...and add whatever else you want to do now that the app has started...
    // NOTE: ...or create your own init handlers outside of this file that trigger off the "app.Ready" event...

    app.initDebug() ;           // just for debug, not required; keep it if you want it or get rid of it
    app.hideSplashScreen() ;    // after init is good time to remove splash screen; using a splash screen is optional

    // app initialization is done
    // app event handlers are ready
    // exit to idle state and wait for app events...

    app.consoleLog(fName, "exit") ;
} ;
document.addEventListener("app.Ready", app.initEvents, false) ;



// Just a bunch of useful debug console.log() messages.
// Runs after underlying device native code and webview/browser is ready.
// The following is just for debug, not required; keep it if you want or get rid of it.

app.initDebug = function() {
    "use strict" ;
    var fName = "app.initDebug():" ;
    app.consoleLog(fName, "entry") ;

    if( window.device && device.cordova ) {                     // old Cordova 2.x version detection
        app.consoleLog("device.version: " + device.cordova) ;   // print the cordova version string...
        app.consoleLog("device.model: " + device.model) ;
        app.consoleLog("device.platform: " + device.platform) ;
        app.consoleLog("device.version: " + device.version) ;
    }

    if( window.cordova && cordova.version ) {                   // only works in Cordova 3.x
        app.consoleLog("cordova.version: " + cordova.version) ; // print new Cordova 3.x version string...

        if( cordova.require ) {                                 // print included cordova plugins
            app.consoleLog(JSON.stringify(cordova.require('cordova/plugin_list').metadata, null, 1)) ;
        }
    }

    app.consoleLog(fName, "exit") ;
} ;



// Using a splash screen is optional. This function will not fail if none is present.
// This is also a simple study in the art of multi-platform device API detection.

app.hideSplashScreen = function() {
    "use strict" ;
    var fName = "app.hideSplashScreen():" ;
    app.consoleLog(fName, "entry") ;

    // see https://github.com/01org/appframework/blob/master/documentation/detail/%24.ui.launch.md
    // Do the following if you disabled App Framework autolaunch (in index.html, for example)
    // $.ui.launch() ;

    if( navigator.splashscreen && navigator.splashscreen.hide ) {   // Cordova API detected
        navigator.splashscreen.hide() ;
    }
    if( window.intel && intel.xdk && intel.xdk.device ) {           // Intel XDK device API detected, but...
        if( intel.xdk.device.hideSplashScreen )                     // ...hideSplashScreen() is inside the base plugin
            intel.xdk.device.hideSplashScreen() ;
    }

    app.consoleLog(fName, "exit") ;
} ;



var onDeviceReady=function() {
    //login if user account exists. checkPushUser fires push.enable event to tell if the user was logged in or not.    
    AppMobi.notification.checkPushUser(AppMobi.device.uuid, AppMobi.device.uuid);
};

document.addEventListener("appMobi.device.ready",onDeviceReady,false);
        
var notificationsRegistered=function(event) {
    //couldn't be logged in. 
    if(event.success === false) {
        //Becz user is not registered.
        if (AppMobi.cache.getCookie("didAddPushUser") === undefined) {
            AppMobi.cache.setCookie("didAddPushUser",AppMobi.device.uuid,-1);
            AppMobi.notification.addPushUser(AppMobi.device.uuid, AppMobi.device.uuid, "no@email.com");
           
            return;
        } else {
            //some other reason. Check event.message property
        }
        return;
    } else {
        //user has been successfully logged in
    }
};

document.addEventListener("appMobi.notification.push.enable",notificationsRegistered,false);


var receivedPush = function(){
    //Get the notifications object
    var myNotifications=AppMobi.notification.getNotificationList();
    //It may contain more than one message, so iterate over them
    var len=myNotifications.length;
    if(len > 0) {
        for(i=0; i < len; i++) {
            
            msgObj=AppMobi.notification.getNotificationData(myNotifications[i]);
            try{
                if(typeof msgObj == "object" && msgObj.id == myNotifications[i]){
       
                    var precio = JSON.parse(msgObj.data);
                    
                    if(precio.s1===null && precio.s1 === undefined) {
                        
                        
                        document.getElementById("s1").innerHTML=precio.s1+" BsF.";
                        document.getElementById("s2").innerHTML=precio.s2+" BsF.";
                        document.getElementById("s3").innerHTML=precio.s3+" BsF.";
                        document.getElementById("d1").innerHTML=precio.t;
                        document.getElementById("d2").innerHTML=precio.t;
                        document.getElementById("d3").innerHTML=precio.t;

                    }
                    
                    
                    AppMobi.notification.deletePushNotifications(msgObj.id);
                    
                    return;
                }
            }catch(e){
                AppMobi.notification.deletePushNotifications(msgObj.id);
            }
        }
    }
};

document.addEventListener("appMobi.notification.push.receive", receivedPush, false);
//app changes it state to foreground.
document.addEventListener("intel.xdk.device.resume",receivedPush,false);

AppMobi.notification.deletePushUser();

document.addEventListener("appMobi.notification.push.disable",deletePushUserEvent,false);

var deletePushUserEvent=function(event)
{
    if(event.success==false)
    {
        //error occured. Check event.message
    }
    else
    {
        //success
    }
}